import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * The space is te escenary where the user play, this escenary is used like main of the game.
 * 
 * @author (Arturo Aaron Rios Obregon) 
 * @version (25 june 2013)
 */
public class Juego extends World
{
    private Hero heroe;
    private Counter level;
    private Counter score;
    private Counter life;
    private Counter bomb;
    private Counter munition;
    private int numEne;
    private int finalLevel;
    private int contEne;
    private ArrayList l;
    private boolean eneFin;
    
    /**
     * Constructor for objects of class Space.
     * 
     */
    public Juego()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1,false); 
        setPaintOrder(Counter.class,LaserMadre.class,IniLaser.class,BulletEnemy.class,Laser.class,Hero.class,Enemy.class,MotherShip.class);
        heroe = new Hero();
        addObject(heroe,300,300);
        level = new Counter("Level: ");
        addObject(level,50,20);
        level.setValue(1);
        life = new Counter("Life: ");
        addObject(life,50,50);
        life.setValue(heroe.getVida());
        score = new Counter("Score: ");
        addObject(score,150,20);
        munition = new Counter("Munition: ");
        addObject(munition,50,80);
        munition.setValue(heroe.getAmmo());
        bomb = new Counter("Bomb: ");
        addObject(bomb,50,110);
        bomb.setValue(heroe.getBomb());
        eneFin=false;
        finalLevel=8;
        numEne=10;
        contEne=0;
        
    }
    
    /**
     * This method is used like the main.
     */
    public void act()
    {
        
        l=(ArrayList)getObjects(Enemy.class);
        if(eneFin==true&&l.isEmpty())
            Greenfoot.stop();
        if(l.isEmpty()&&level.getValue()!=finalLevel)  //crea la horda
        {
            for(int i=0;i<5;i++)
                creaEnemigoR();
            contEne+=5;
        }
        if(level.getValue()==finalLevel&&eneFin==false&&l.isEmpty()) //nivel final
        {
            MotherShip m = new MotherShip();
            addObject(m,300,10);
            eneFin=true;
        }
        if(contEne==numEne&&l.isEmpty()&&level.getValue()!=finalLevel) //aumenta nivel
        {
            numEne+=5;
            contEne=0;
            level.add(1);
        }        
        
        actualiza();
        if(heroe.getVida()==0)
        {
            Greenfoot.stop();
        }
    }
    
    /**
     * This methos actualize the counters on the game.
     */
    public void actualiza()
    {
        life.setValue(heroe.getVida());
        munition.setValue(heroe.getAmmo());
        bomb.setValue(heroe.getBomb());
    }
    
    /**
     * This method help to up the score of the player.
     */
    public void aumentaPuntos(int cant)
    {
        score.add(cant);
    }
    
    /**
     * This method create the enemys on the game.
     */
    public void creaEnemigoR()
    {
        switch(Greenfoot.getRandomNumber(5)%level.getValue())
        {
            case 0:
                    Meteor n1 = new Meteor();
                    addObject(n1,randomX(),20);
                    break;
            case 1:
                    BasicEnemy n2 = new BasicEnemy();
                    addObject(n2,randomX(),20);
                    break;
            case 2:
                    NormalEnemy n3 = new NormalEnemy();
                    addObject(n3,randomX(),20);
                    break;  
            case 3:
                    DupEnemy n4 = new DupEnemy();
                    addObject(n4,randomX(),20);
                    break;  
            case 4:
                    ProducerEnemy n5 = new ProducerEnemy();
                    addObject(n5,randomX(),20);
                    break;
                    
        }
    }
    
    /**
     * This method give a random position on x.
     */
    public int randomX()
    {
        int num=0;
        switch(Greenfoot.getRandomNumber(6))
        {
            case 0:
                num= 50;
                break;
            case 1:
                num= 150;
                break;
            case 2:
                num= 250;
                break;
            case 3:
                num= 350;
                break;
            case 4:
                num= 450;
                break;
            case 5:
                num= 550;
                break;
        }
        return num;
    }
    
    /**
     * This methos return the hero.
     */
    public Hero getHero()
    {
        return heroe;
    }
}
